// 
// Decompiled by Procyon v1.0-SNAPSHOT
// 

package FlatTop;

import java.awt.BorderLayout;
import javax.swing.JLayeredPane;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import javax.swing.DefaultCellEditor;
import javax.swing.table.TableCellEditor;
import java.awt.event.FocusEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableModel;
import javax.swing.JTable;
import javax.swing.JComboBox;
import javax.swing.JColorChooser;
import java.awt.Dimension;
import javax.swing.table.DefaultTableModel;
import java.awt.event.FocusListener;
import javax.swing.JDialog;
import VASSAL.counters.PieceEditor;
import java.net.MalformedURLException;
import java.io.File;
import VASSAL.build.module.Documentation;
import VASSAL.build.module.documentation.HelpFile;
import java.awt.Point;
import javax.swing.JComponent;
import java.awt.Container;
import VASSAL.build.module.Map;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import javax.swing.JPanel;
import VASSAL.counters.Marker;
import javax.swing.JSpinner;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.GridBagLayout;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Frame;
import javax.swing.JFrame;
import VASSAL.command.Command;
import VASSAL.command.ChangePiece;
import VASSAL.build.GameModule;
import javax.swing.text.JTextComponent;
import javax.swing.JLabel;
import javax.swing.KeyStroke;
import VASSAL.tools.SequenceEncoder;
import java.awt.Shape;
import java.awt.Rectangle;
import java.awt.Component;
import java.awt.Graphics;
import VASSAL.tools.SequenceEncoder.Decoder;
import VASSAL.counters.GamePiece;
import java.util.Vector;
import javax.swing.JButton;
import java.awt.Color;
import VASSAL.counters.KeyCommand;
import VASSAL.counters.EditablePiece;
import VASSAL.counters.Decorator;

public class FlatTopPropertySheet extends Decorator implements EditablePiece
{
    public static final String ID = "propertysheet;";
    protected String oldState;
    protected String menuName;
    protected char launchKey;
    protected KeyCommand launch;
    protected Color backgroundColor;
    String m_definition;
    protected PropertySheetDialog frame;
    protected JButton applyButton;
    static final String[] COMMIT_VALUES;
    static final int COMMIT_IMMEDIATELY = 0;
    static final int COMMIT_ON_APPLY = 1;
    static final int COMMIT_ON_CLOSE = 2;
    static final int COMMIT_DEFAULT = 0;
    static final String[] TYPE_VALUES;
    static final int TEXT_FIELD = 0;
    static final int TEXT_AREA = 1;
    static final int LABEL_ONLY = 2;
    static final int TICKS = 3;
    static final int TICKS_MAX = 4;
    static final int TICKS_VAL = 5;
    static final int TICKS_VALMAX = 6;
    static final int SPINNER = 7;
    static final int PROPERTYVALUE = 8;
    protected int commitStyle;
    protected boolean isUpdating;
    String state;
    Vector m_values;
    Vector m_fields;
    static final char TYPE_DELIMITOR = ';';
    static final char DEF_DELIMITOR = '~';
    static final char STATE_DELIMITOR = '~';
    static final char LINE_DELIMINATOR = '|';
    static final char VALUE_DELIMINATOR = '/';
    
    static {
        COMMIT_VALUES = new String[] { "Every Keystroke", "Apply Button or Enter Key", "Close Window or Enter Key" };
        TYPE_VALUES = new String[] { "Text", "Multi-line text", "Label Only", "Tick Marks", "Tick Marks with Max Field", "Tick Marks with Value Field", "Tick Marks with Value & Max", "Spinner", "Property Value" };
    }
    
    public FlatTopPropertySheet() {
        this("propertysheet;;Properties;P;;;;", null);
    }
    
    public FlatTopPropertySheet(final String type, final GamePiece p) {
        this.commitStyle = 0;
        this.mySetType(type);
        this.setInner(p);
    }
    
    public void mySetType(String s) {
        s = s.substring("propertysheet;".length());
        final SequenceEncoder.Decoder st = new SequenceEncoder.Decoder(s, ';');
        this.m_definition = st.nextToken();
        this.menuName = st.nextToken();
        this.launchKey = st.nextChar('\0');
        this.commitStyle = st.nextInt(0);
        final String red = st.hasMoreTokens() ? st.nextToken() : "";
        final String green = st.hasMoreTokens() ? st.nextToken() : "";
        final String blue = st.hasMoreTokens() ? st.nextToken() : "";
        this.backgroundColor = (red.equals("") ? null : new Color(this.atoi(red), this.atoi(green), this.atoi(blue)));
        this.frame = null;
    }
    
    public void draw(final Graphics g, final int x, final int y, final Component obs, final double zoom) {
        this.piece.draw(g, x, y, obs, zoom);
    }
    
    public String getName() {
        return this.piece.getName();
    }
    
    public Rectangle boundingBox() {
        return this.piece.boundingBox();
    }
    
    public Shape getShape() {
        return this.piece.getShape();
    }
    
    public String myGetState() {
        return this.state;
    }
    
    public void mySetState(final String state) {
        this.state = state;
        this.updateFieldsFromState();
    }
    
    public String myGetType() {
        final SequenceEncoder se = new SequenceEncoder(';');
        final String red = (this.backgroundColor == null) ? "" : Integer.toString(this.backgroundColor.getRed());
        final String green = (this.backgroundColor == null) ? "" : Integer.toString(this.backgroundColor.getGreen());
        final String blue = (this.backgroundColor == null) ? "" : Integer.toString(this.backgroundColor.getBlue());
        final String commit = Integer.toString(this.commitStyle);
        se.append(this.m_definition).append(this.menuName).append(this.launchKey).append(commit).append(red).append(green).append(blue);
        return "propertysheet;" + se.getValue();
    }
    
    protected KeyCommand[] myGetKeyCommands() {
        if (this.launch == null) {
            this.launch = new KeyCommand(this.menuName, KeyStroke.getKeyStroke(this.launchKey, 2), Decorator.getOutermost((GamePiece)this));
        }
        return new KeyCommand[] { this.launch };
    }
    
    int atoi(final String s) {
        int value = 0;
        if (s != null) {
            for (int i = 0; i < s.length() && Character.isDigit(s.charAt(i)); ++i) {
                value = value * 10 + s.charAt(i) - 48;
            }
        }
        return value;
    }
    
    int atoiRight(final String s) {
        int value = 0;
        if (s != null) {
            for (int base = 1, i = s.length() - 1; i >= 0 && Character.isDigit(s.charAt(i)); --i, base *= 10) {
                value += base * (s.charAt(i) - '0');
            }
        }
        return value;
    }
    
    public void SetFieldValue(final String name, final String value) {
        if (this.frame == null || this.m_fields.size() == 0) {
            return;
        }
        this.updateFieldsFromState();
        for (int i = 0; i < this.m_fields.size(); ++i) {
            final Object field = this.m_fields.get(i);
            if (field instanceof JLabel) {
                final JLabel comp = (JLabel)field;
                if (comp.getName().equals(name)) {
                    comp.setText(value);
                    break;
                }
            }
        }
        this.updateStateFromFields();
    }
    
    private void updateStateFromFields() {
        final SequenceEncoder encoder = new SequenceEncoder('~');
        for (int iCtrl = 0; iCtrl < this.m_fields.size(); ++iCtrl) {
            final Object field = this.m_fields.get(iCtrl);
            if (field instanceof JTextComponent) {
                encoder.append(((JTextComponent)field).getText().replace('\n', '|'));
            }
            else if (field instanceof TickPanel) {
                encoder.append(((TickPanel)field).getValue());
            }
            else {
                encoder.append("Unknown");
            }
        }
        if (this.state != encoder.getValue()) {
            this.state = encoder.getValue();
            final GamePiece outer = Decorator.getOutermost((GamePiece)this);
            if (outer.getId() != null) {
                GameModule.getGameModule().sendAndLog((Command)new ChangePiece(outer.getId(), this.oldState, outer.getState()));
            }
        }
    }
    
    private void updateFieldsFromState() {
        this.isUpdating = true;
        if (this.frame != null) {
            final SequenceEncoder.Decoder stateDecoder = new SequenceEncoder.Decoder(this.state, '~');
            int iField = 0;
            while (stateDecoder.hasMoreTokens()) {
                String value = stateDecoder.nextToken();
                value = value.replace('|', '\n');
                if (this.frame != null) {
                    final Object field = this.m_fields.get(iField);
                    if (field instanceof JTextComponent) {
                        ((JTextComponent)field).setText(value);
                    }
                    else if (field instanceof TickPanel) {
                        ((TickPanel)field).updateValue(value);
                    }
                }
                ++iField;
            }
            if (this.applyButton != null) {
                this.applyButton.setEnabled(false);
            }
        }
        this.isUpdating = false;
    }
    
    public Command myKeyEvent(final KeyStroke stroke) {
        this.myGetKeyCommands();
        if (this.launch.matches(stroke)) {
            if (this.frame == null) {
                this.m_fields = new Vector();
                final Map map = this.piece.getMap();
                Frame parent = null;
                if (map != null && map.getView() != null) {
                    final Container topWin = map.getView().getTopLevelAncestor();
                    if (topWin instanceof JFrame) {
                        parent = (Frame)topWin;
                    }
                }
                this.frame = new PropertySheetDialog(parent);
                final Container pane = this.frame.getContentPane();
                if (this.commitStyle == 1) {
                    (this.applyButton = new JButton("Apply")).addActionListener(new ActionListener() {
                        public void actionPerformed(final ActionEvent event) {
                            if (FlatTopPropertySheet.this.applyButton != null) {
                                FlatTopPropertySheet.this.applyButton.setEnabled(false);
                            }
                            FlatTopPropertySheet.this.updateStateFromFields();
                        }
                    });
                    this.applyButton.setMnemonic(65);
                    this.applyButton.setEnabled(false);
                }
                final DocumentListener changeListener = new DocumentListener() {
                    public void insertUpdate(final DocumentEvent e) {
                        this.update(e);
                    }
                    
                    public void removeUpdate(final DocumentEvent e) {
                        this.update(e);
                    }
                    
                    public void changedUpdate(final DocumentEvent e) {
                        this.update(e);
                    }
                    
                    public void update(final DocumentEvent e) {
                        if (!FlatTopPropertySheet.this.isUpdating) {
                            switch (FlatTopPropertySheet.this.commitStyle) {
                                case 0: {
                                    SwingUtilities.invokeLater(new Runnable() {
                                        public void run() {
                                            FlatTopPropertySheet.this.updateStateFromFields();
                                        }
                                    });
                                    break;
                                }
                                case 1: {
                                    FlatTopPropertySheet.this.applyButton.setEnabled(true);
                                    break;
                                }
                                case 2: {
                                    break;
                                }
                                default: {
                                    throw new RuntimeException();
                                }
                            }
                        }
                    }
                };
                pane.setLayout(new GridBagLayout());
                final GridBagConstraints c = new GridBagConstraints();
                c.fill = 1;
                c.insets = new Insets(1, 3, 1, 3);
                c.gridx = 0;
                c.gridy = 0;
                c.fill = 1;
                final SequenceEncoder.Decoder defDecoder = new SequenceEncoder.Decoder(this.m_definition, '~');
                final SequenceEncoder.Decoder stateDecoder = new SequenceEncoder.Decoder(this.state, '~');
                while (defDecoder.hasMoreTokens()) {
                    final String code = defDecoder.nextToken();
                    if (code.length() == 0) {
                        break;
                    }
                    final int type = code.charAt(0) - '0';
                    final String name = code.substring(1);
                    JComponent field = null;
                    switch (type) {
                        case 0: {
                            field = new JTextField(stateDecoder.nextToken());
                            ((JTextComponent)field).getDocument().addDocumentListener(changeListener);
                            ((JTextField)field).addActionListener(this.frame);
                            this.m_fields.add(field);
                            break;
                        }
                        case 1: {
                            field = new JTextArea(stateDecoder.nextToken().replace('|', '\n'));
                            ((JTextComponent)field).getDocument().addDocumentListener(changeListener);
                            this.m_fields.add(field);
                            field = new JScrollPane(field);
                            break;
                        }
                        case 3:
                        case 4:
                        case 5:
                        case 6: {
                            field = new TickPanel(stateDecoder.nextToken(), type);
                            ((TickPanel)field).addDocumentListener(changeListener);
                            ((TickPanel)field).addActionListener(this.frame);
                            if (this.backgroundColor != null) {
                                field.setBackground(this.backgroundColor);
                            }
                            this.m_fields.add(field);
                            break;
                        }
                        case 7: {
                            final JSpinner spinner = new JSpinner();
                            final JTextField textField = ((JSpinner.DefaultEditor)spinner.getEditor()).getTextField();
                            textField.setText(stateDecoder.nextToken());
                            textField.getDocument().addDocumentListener(changeListener);
                            this.m_fields.add(textField);
                            field = spinner;
                            break;
                        }
                        case 8: {
                            field = null;
                            try {
                                for (Decorator dec = (Decorator)Decorator.getOutermost((GamePiece)this); dec != null; dec = (Decorator)dec.getInner()) {
                                    if (dec instanceof Marker) {
                                        final Marker marker = (Marker)dec;
                                        try {
                                            final String val = marker.getProperty((Object)name).toString();
                                            field = new JLabel(val);
                                            field.setName(name);
                                            this.m_fields.add(field);
                                            break;
                                        }
                                        catch (NullPointerException ex) {}
                                    }
                                }
                            }
                            catch (Exception ex2) {}
                            if (field == null) {
                                field = new JLabel("-");
                                field.setName(name);
                                this.m_fields.add(field);
                                break;
                            }
                            break;
                        }
                        default: {
                            field = null;
                            break;
                        }
                    }
                    c.gridwidth = ((type == 1 || type == 2) ? 2 : 1);
                    if (name != null && !name.equals("")) {
                        c.gridx = 0;
                        c.weighty = 0.0;
                        c.weightx = ((c.gridwidth == 2) ? 1.0 : 0.0);
                        pane.add(new JLabel(name), c);
                        if (c.gridwidth == 2) {
                            final GridBagConstraints gridBagConstraints = c;
                            ++gridBagConstraints.gridy;
                        }
                    }
                    if (field == null) {
                        continue;
                    }
                    c.weightx = 1.0;
                    c.weighty = ((type == 1) ? 1.0 : 0.0);
                    c.gridx = ((type != 1) ? 1 : 0);
                    pane.add(field, c);
                    final GridBagConstraints gridBagConstraints2 = c;
                    ++gridBagConstraints2.gridy;
                }
                if (this.backgroundColor != null) {
                    pane.setBackground(this.backgroundColor);
                }
                if (this.commitStyle == 1) {
                    final JButton closeButton = new JButton("Close");
                    closeButton.setMnemonic(67);
                    closeButton.addActionListener(new ActionListener() {
                        public void actionPerformed(final ActionEvent e) {
                            FlatTopPropertySheet.this.updateStateFromFields();
                            FlatTopPropertySheet.this.frame.setVisible(false);
                        }
                    });
                    c.gridwidth = 1;
                    c.weighty = 0.0;
                    c.anchor = 14;
                    c.gridwidth = 2;
                    c.gridx = 0;
                    c.weightx = 0.0;
                    final JPanel buttonRow = new JPanel();
                    buttonRow.add(this.applyButton);
                    buttonRow.add(closeButton);
                    if (this.backgroundColor != null) {
                        this.applyButton.setBackground(this.backgroundColor);
                        closeButton.setBackground(this.backgroundColor);
                        buttonRow.setBackground(this.backgroundColor);
                    }
                    pane.add(buttonRow, c);
                }
                Point p = GameModule.getGameModule().getFrame().getLocation();
                if (this.getMap() != null) {
                    p = this.getMap().getView().getLocationOnScreen();
                    final Point p2 = this.getMap().mapToComponent(this.getPosition());
                    p.translate(p2.x, p2.y);
                }
                this.frame.setLocation(p.x, p.y);
                this.frame.addWindowListener(new WindowAdapter() {
                    public void windowClosing(final WindowEvent evt) {
                        FlatTopPropertySheet.this.updateStateFromFields();
                    }
                });
                this.frame.pack();
            }
            this.frame.setTitle(this.getName());
            this.oldState = Decorator.getOutermost((GamePiece)this).getState();
            this.frame.setVisible(true);
            return null;
        }
        return null;
    }
    
    public String getDescription() {
        return "Property Sheet";
    }
    
    public HelpFile getHelpFile() {
        File dir = Documentation.getDocumentationBaseDir();
        dir = new File(dir, "ReferenceManual");
        try {
            return new HelpFile((String)null, new File(dir, "PropertySheet.htm"));
        }
        catch (MalformedURLException ex) {
            return null;
        }
    }
    
    public PieceEditor getEditor() {
        return (PieceEditor)new Ed(this);
    }
    
    class PropertySheetDialog extends JDialog implements ActionListener
    {
        public PropertySheetDialog(final Frame owner) {
            super(owner, false);
        }
        
        public void actionPerformed(final ActionEvent event) {
            if (FlatTopPropertySheet.this.applyButton != null) {
                FlatTopPropertySheet.this.applyButton.setEnabled(false);
            }
            FlatTopPropertySheet.this.updateStateFromFields();
        }
    }
    
    static class PropertyPanel extends JPanel implements FocusListener
    {
        GridBagConstraints c;
        DefaultTableModel tableModel;
        String[] defaultValues;
        
        public PropertyPanel() {
            super(new GridBagLayout());
            this.c = new GridBagConstraints();
            this.c.insets = new Insets(0, 4, 0, 4);
            this.c.anchor = 17;
        }
        
        public JTextField addKeystrokeCtrl(final char value) {
            final GridBagConstraints c = this.c;
            ++c.gridy;
            this.c.gridx = 0;
            this.c.weightx = 0.0;
            this.c.fill = 0;
            this.add(new JLabel("Keystroke"), this.c);
            final GridBagConstraints c2 = this.c;
            ++c2.gridx;
            final JTextField field = new JTextField(Character.toString(value));
            final Dimension minSize = field.getMinimumSize();
            minSize.width = 30;
            field.setMinimumSize(minSize);
            field.setPreferredSize(minSize);
            this.add(field, this.c);
            field.setSize(minSize);
            return field;
        }
        
        public JTextField addStringCtrl(final String name, final String value) {
            final GridBagConstraints c = this.c;
            ++c.gridy;
            this.c.gridx = 0;
            this.c.weightx = 0.0;
            this.c.fill = 2;
            this.add(new JLabel(name), this.c);
            this.c.weightx = 1.0;
            final JTextField field = new JTextField(value);
            final GridBagConstraints c2 = this.c;
            ++c2.gridx;
            this.add(field, this.c);
            return field;
        }
        
        public JButton addColorCtrl(final String name, final Color value) {
            final GridBagConstraints c = this.c;
            ++c.gridy;
            this.c.gridx = 0;
            this.c.weightx = 0.0;
            this.c.fill = 0;
            this.add(new JLabel(name), this.c);
            this.c.weightx = 0.0;
            final JButton button = new JButton("Default");
            if (value != null) {
                button.setBackground(value);
                button.setText("sample");
            }
            button.addActionListener(new ActionListener() {
                public void actionPerformed(final ActionEvent event) {
                    final JButton button = (JButton)event.getSource();
                    final Color value = button.getBackground();
                    final Color newColor = JColorChooser.showDialog(button, "Choose background color or CANCEL to use default color scheme", value);
                    if (newColor != null) {
                        button.setBackground(newColor);
                        button.setText("sample");
                    }
                    else {
                        button.setBackground(getBackground());
                        button.setText("Default");
                    }
                }
            });
            final GridBagConstraints c2 = this.c;
            ++c2.gridx;
            this.add(button, this.c);
            return button;
        }
        
        public JComboBox addComboBox(final String name, final String[] values, final int initialRow) {
            final JComboBox comboBox = new JComboBox(values);
            comboBox.setEditable(false);
            comboBox.setSelectedIndex(initialRow);
            this.addCtrl(name, comboBox);
            return comboBox;
        }
        
        public void addCtrl(final String name, final JComponent ctrl) {
            final GridBagConstraints c = this.c;
            ++c.gridy;
            this.c.gridx = 0;
            this.c.weightx = 0.0;
            this.c.fill = 0;
            this.add(new JLabel(name), this.c);
            this.c.weightx = 0.0;
            final GridBagConstraints c2 = this.c;
            ++c2.gridx;
            this.add(ctrl, this.c);
        }
        
        public JTable addTableCtrl(final String name, final DefaultTableModel theTableModel, final String[] theDefaultValues) {
            this.tableModel = theTableModel;
            this.defaultValues = theDefaultValues;
            final GridBagConstraints c = this.c;
            ++c.gridy;
            this.c.gridx = 0;
            this.c.weighty = 0.0;
            this.c.weightx = 1.0;
            this.c.gridwidth = 2;
            this.c.fill = 2;
            this.add(new JLabel(name), this.c);
            final GridBagConstraints c2 = this.c;
            ++c2.gridy;
            this.c.weighty = 1.0;
            this.c.fill = 1;
            final SmartTable table = new SmartTable(this.tableModel);
            this.add(new JScrollPane(table), this.c);
            this.c.gridwidth = 1;
            final GridBagConstraints c3 = this.c;
            ++c3.gridy;
            this.c.fill = 0;
            this.c.anchor = 13;
            this.c.gridwidth = 2;
            this.c.weighty = 0.0;
            this.c.weightx = 1.0;
            final JPanel buttonPanel = new JPanel();
            final JButton addButton = new JButton("Insert Row");
            buttonPanel.add(addButton);
            addButton.addActionListener(new ActionListener() {
                public void actionPerformed(final ActionEvent e) {
                    if (table.isEditing()) {
                        table.getCellEditor().stopCellEditing();
                    }
                    final ListSelectionModel selection = table.getSelectionModel();
                    int iSelection;
                    if (selection.isSelectionEmpty()) {
                        tableModel.addRow(defaultValues);
                        iSelection = tableModel.getRowCount() - 1;
                    }
                    else {
                        iSelection = selection.getMaxSelectionIndex();
                        tableModel.insertRow(iSelection, defaultValues);
                    }
                    tableModel.fireTableDataChanged();
                    selection.setSelectionInterval(iSelection, iSelection);
                    table.grabFocus();
                    table.editCellAt(iSelection, 0);
                    final Component comp = table.getCellEditor().getTableCellEditorComponent(table, null, true, iSelection, 0);
                    if (comp instanceof JComponent) {
                        ((JComponent)comp).grabFocus();
                    }
                }
            });
            final JButton deleteButton = new JButton("Delete Row");
            deleteButton.setEnabled(false);
            buttonPanel.add(deleteButton);
            deleteButton.addActionListener(new ActionListener() {
                public void actionPerformed(final ActionEvent e) {
                    if (table.isEditing()) {
                        table.getCellEditor().stopCellEditing();
                    }
                    final ListSelectionModel selection = table.getSelectionModel();
                    for (int i = selection.getMaxSelectionIndex(); i >= selection.getMinSelectionIndex(); --i) {
                        if (selection.isSelectedIndex(i)) {
                            tableModel.removeRow(i);
                        }
                    }
                    tableModel.fireTableDataChanged();
                }
            });
            table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(final ListSelectionEvent event) {
                    if (!event.getValueIsAdjusting()) {
                        final ListSelectionModel lsm = (ListSelectionModel)event.getSource();
                        deleteButton.setEnabled(!lsm.isSelectionEmpty());
                    }
                }
            });
            this.add(buttonPanel, this.c);
            this.c.anchor = 17;
            this.c.weightx = 0.0;
            return table;
        }
        
        public void focusGained(final FocusEvent event) {
        }
        
        public void focusLost(final FocusEvent event) {
            if (event.getComponent() instanceof JTable) {
                final JTable table = (JTable)event.getComponent();
                if (table.isEditing()) {
                    table.getCellEditor().stopCellEditing();
                }
            }
        }
        
        public class SmartTable extends JTable
        {
            SmartTable(final TableModel m) {
                super(m);
                this.setSurrendersFocusOnKeystroke(true);
            }
            
            public Component prepareEditor(final TableCellEditor editor, final int row, final int column) {
                if (row == this.getRowCount() - 1) {
                    ((DefaultTableModel)this.getModel()).addRow(Ed.DEFAULT_ROW);
                }
                final Component component = super.prepareEditor(editor, row, column);
                if (component instanceof JTextComponent) {
                    ((JTextComponent)component).grabFocus();
                    ((JTextComponent)component).selectAll();
                }
                return component;
            }
        }
    }
    
    private static class Ed implements PieceEditor
    {
        private PropertyPanel m_panel;
        private JTextField menuNameCtrl;
        private JTextField keystrokeCtrl;
        private JButton colorCtrl;
        private JTable propertyTable;
        private JComboBox commitCtrl;
        static final String[] COLUMN_NAMES;
        static final String[] DEFAULT_ROW;
        
        static {
            COLUMN_NAMES = new String[] { "Name", "Type" };
            DEFAULT_ROW = new String[] { "*new property*", "Text" };
        }
        
        public Ed(final FlatTopPropertySheet propertySheet) {
            this.m_panel = new PropertyPanel();
            this.menuNameCtrl = this.m_panel.addStringCtrl("Menu Text", propertySheet.menuName);
            this.keystrokeCtrl = this.m_panel.addKeystrokeCtrl(propertySheet.launchKey);
            this.commitCtrl = this.m_panel.addComboBox("Commit changes on", FlatTopPropertySheet.COMMIT_VALUES, propertySheet.commitStyle);
            this.colorCtrl = this.m_panel.addColorCtrl("Background Color", propertySheet.backgroundColor);
            final DefaultTableModel dataModel = new DefaultTableModel(this.getTableData(propertySheet.m_definition), Ed.COLUMN_NAMES);
            this.AddCreateRow(dataModel);
            this.propertyTable = this.m_panel.addTableCtrl("Properties:", dataModel, Ed.DEFAULT_ROW);
            final DefaultCellEditor typePicklist = new DefaultCellEditor(new JComboBox<Object>((Object[])FlatTopPropertySheet.TYPE_VALUES));
            this.propertyTable.getColumnModel().getColumn(1).setCellEditor(typePicklist);
        }
        
        protected void AddCreateRow(final DefaultTableModel data) {
            data.addRow(Ed.DEFAULT_ROW);
        }
        
        protected String[][] getTableData(final String definition) {
            final SequenceEncoder.Decoder decoder = new SequenceEncoder.Decoder(definition, '~');
            int numRows = (!definition.equals("") && decoder.hasMoreTokens()) ? 1 : 0;
            int iDef = -1;
            while ((iDef = definition.indexOf(126, iDef + 1)) >= 0) {
                ++numRows;
            }
            final String[][] rows = new String[numRows][2];
            for (int iRow = 0; decoder.hasMoreTokens() && iRow < numRows; ++iRow) {
                final String token = decoder.nextToken();
                rows[iRow][0] = token.substring(1);
                rows[iRow][1] = FlatTopPropertySheet.TYPE_VALUES[token.charAt(0) - '0'];
            }
            return rows;
        }
        
        public Component getControls() {
            return this.m_panel;
        }
        
        public String getType() {
            if (this.propertyTable.isEditing()) {
                this.propertyTable.getCellEditor().stopCellEditing();
            }
            final SequenceEncoder defEncoder = new SequenceEncoder('~');
            for (int iRow = 0; iRow < this.propertyTable.getRowCount(); ++iRow) {
                final String typeString = (String)this.propertyTable.getValueAt(iRow, 1);
                for (int iType = 0; iType < FlatTopPropertySheet.TYPE_VALUES.length; ++iType) {
                    if (typeString.matches(FlatTopPropertySheet.TYPE_VALUES[iType]) && !Ed.DEFAULT_ROW[0].equals(this.propertyTable.getValueAt(iRow, 0))) {
                        defEncoder.append(String.valueOf(iType) + (String)this.propertyTable.getValueAt(iRow, 0));
                        break;
                    }
                }
            }
            final SequenceEncoder typeEncoder = new SequenceEncoder(';');
            String red;
            String green;
            String blue;
            if (this.colorCtrl.getText().equals("Default")) {
                red = "";
                green = "";
                blue = "";
            }
            else {
                red = Integer.toString(this.colorCtrl.getBackground().getRed());
                green = Integer.toString(this.colorCtrl.getBackground().getGreen());
                blue = Integer.toString(this.colorCtrl.getBackground().getBlue());
            }
            final String definitionString = defEncoder.getValue();
            typeEncoder.append((definitionString == null) ? "" : definitionString).append(this.menuNameCtrl.getText()).append(this.keystrokeCtrl.getText()).append(Integer.toString(this.commitCtrl.getSelectedIndex())).append(red).append(green).append(blue);
            return "propertysheet;" + typeEncoder.getValue();
        }
        
        public String getState() {
            final StringBuffer buf = new StringBuffer();
            for (int i = 0; i < this.propertyTable.getRowCount(); ++i) {
                buf.append('~');
            }
            return buf.toString();
        }
    }
    
    class TickPanel extends JPanel implements ActionListener, FocusListener, DocumentListener
    {
        private int numTicks;
        private int maxTicks;
        private int panelType;
        private JTextField valField;
        private JTextField maxField;
        private TickLabel ticks;
        private Vector actionListeners;
        private Vector documentListeners;
        
        public TickPanel(final String value, final int type) {
            super(new GridBagLayout());
            this.actionListeners = new Vector();
            this.documentListeners = new Vector();
            this.set(value);
            this.panelType = type;
            final GridBagConstraints c = new GridBagConstraints();
            c.fill = 1;
            c.ipadx = 1;
            c.weightx = 0.0;
            c.gridx = 0;
            c.gridy = 0;
            if (this.panelType == 5 || this.panelType == 6) {
                this.valField = new JTextField(Integer.toString(this.numTicks));
                final Dimension minSize = this.valField.getMinimumSize();
                minSize.width = 24;
                this.valField.setMinimumSize(minSize);
                this.valField.setPreferredSize(minSize);
                this.valField.addActionListener(this);
                this.valField.addFocusListener(this);
                this.add(this.valField, c);
                final GridBagConstraints gridBagConstraints = c;
                ++gridBagConstraints.gridx;
            }
            if (this.panelType == 4 || this.panelType == 6) {
                this.maxField = new JTextField(Integer.toString(this.maxTicks));
                final Dimension minSize = this.maxField.getMinimumSize();
                minSize.width = 24;
                this.maxField.setMinimumSize(minSize);
                this.maxField.setPreferredSize(minSize);
                this.maxField.addActionListener(this);
                this.maxField.addFocusListener(this);
                if (this.panelType == 6) {
                    this.add(new JLabel("/"), c);
                    final GridBagConstraints gridBagConstraints2 = c;
                    ++gridBagConstraints2.gridx;
                }
                this.add(this.maxField, c);
                final GridBagConstraints gridBagConstraints3 = c;
                ++gridBagConstraints3.gridx;
            }
            (this.ticks = new TickLabel(this.numTicks, this.maxTicks, this.panelType)).addActionListener(this);
            c.weightx = 1.0;
            this.add(this.ticks, c);
            this.doLayout();
        }
        
        public void updateValue(final String value) {
            this.set(value);
            this.updateFields();
        }
        
        private void set(final String value) {
            this.set(FlatTopPropertySheet.this.atoi(value), FlatTopPropertySheet.this.atoiRight(value));
        }
        
        private boolean set(int num, int max) {
            boolean changed = false;
            if (this.numTicks == 0 && this.maxTicks == 0 && num == 0 && max > 0) {
                num = max;
                changed = true;
            }
            if (this.numTicks == 0 && this.maxTicks == 0 && max == 0 && num > 0) {
                max = num;
                changed = true;
            }
            this.numTicks = Math.min(max, num);
            this.maxTicks = max;
            return changed;
        }
        
        public String getValue() {
            this.commitTextFields();
            return String.valueOf(Integer.toString(this.numTicks)) + '/' + this.maxTicks;
        }
        
        private void commitTextFields() {
            if ((this.valField != null || this.maxField != null) && this.set((this.valField != null) ? FlatTopPropertySheet.this.atoi(this.valField.getText()) : this.numTicks, (this.maxField != null) ? FlatTopPropertySheet.this.atoi(this.maxField.getText()) : this.maxTicks)) {
                this.updateFields();
            }
        }
        
        private void updateFields() {
            if (this.valField != null) {
                this.valField.setText(Integer.toString(this.numTicks));
            }
            if (this.maxField != null) {
                this.maxField.setText(Integer.toString(this.maxTicks));
            }
            this.ticks.set(this.numTicks, this.maxTicks);
        }
        
        private boolean areFieldValuesValid() {
            final int max = (this.maxField == null) ? this.maxTicks : FlatTopPropertySheet.this.atoi(this.maxField.getText());
            final int val = (this.valField == null) ? this.numTicks : FlatTopPropertySheet.this.atoi(this.valField.getText());
            return val < max && val >= 0;
        }
        
        public void actionPerformed(final ActionEvent event) {
            if (event.getSource() == this.maxField || event.getSource() == this.valField) {
                this.commitTextFields();
                this.ticks.set(this.numTicks, this.maxTicks);
                this.fireActionEvent();
            }
            else if (event.getSource() == this.ticks) {
                this.commitTextFields();
                this.numTicks = this.ticks.getNumTicks();
                if (this.maxField == null) {
                    this.maxTicks = this.ticks.getMaxTicks();
                }
                this.updateFields();
                this.fireDocumentEvent();
            }
        }
        
        public void addActionListener(final ActionListener listener) {
            this.actionListeners.add(listener);
        }
        
        public void fireActionEvent() {
            final Iterator<ActionListener> it = this.actionListeners.iterator();
            while (it.hasNext()) {
                it.next().actionPerformed(new ActionEvent(this, 0, null));
            }
        }
        
        void addDocumentListener(final DocumentListener listener) {
            if (this.valField != null) {
                this.valField.getDocument().addDocumentListener(this);
            }
            if (this.maxField != null) {
                this.maxField.getDocument().addDocumentListener(this);
            }
            this.documentListeners.add(listener);
        }
        
        public void fireDocumentEvent() {
            final Iterator<DocumentListener> it = this.documentListeners.iterator();
            while (it.hasNext()) {
                it.next().changedUpdate(null);
            }
        }
        
        public void focusLost(final FocusEvent event) {
            this.commitTextFields();
            this.ticks.set(this.numTicks, this.maxTicks);
        }
        
        public void focusGained(final FocusEvent event) {
        }
        
        public void changedUpdate(final DocumentEvent event) {
            if (this.areFieldValuesValid()) {
                this.fireDocumentEvent();
            }
        }
        
        public void insertUpdate(final DocumentEvent event) {
            this.changedUpdate(event);
        }
        
        public void removeUpdate(final DocumentEvent event) {
            this.changedUpdate(event);
        }
    }
    
    class TickLabel extends JLabel implements MouseListener
    {
        private int numTicks;
        private int maxTicks;
        protected int panelType;
        private Vector<ActionListener> actionListeners;
        protected int topMargin;
        protected int leftMargin;
        protected int numRows;
        protected int numCols;
        protected int dx;
        
        public int getNumTicks() {
            return this.numTicks;
        }
        
        public int getMaxTicks() {
            return this.maxTicks;
        }
        
        public void addActionListener(final ActionListener listener) {
            this.actionListeners.add(listener);
        }
        
        public TickLabel(final int numTicks, final int maxTicks, final int panelType) {
            super(" ");
            this.numTicks = 0;
            this.maxTicks = 0;
            this.actionListeners = new Vector();
            this.topMargin = 2;
            this.leftMargin = 2;
            this.dx = 1;
            this.set(numTicks, maxTicks);
            this.panelType = panelType;
            this.addMouseListener(this);
        }
        
        public void paint(final Graphics g) {
            if (this.maxTicks > 0) {
                final int displayWidth = this.getWidth() - 2;
                this.dx = Math.min(displayWidth / this.maxTicks, 10);
                this.numRows = ((this.dx < 3) ? 3 : ((this.dx < 6) ? 2 : 1));
                this.dx = Math.min(displayWidth * this.numRows / this.maxTicks, Math.min(this.getHeight() / this.numRows, 10));
                this.numCols = (this.maxTicks + this.numRows - 1) / this.numRows;
                final int dy = this.dx;
                this.topMargin = (this.getHeight() - dy * this.numRows + 2) / 2;
                int tick = 0;
                if (this.dx > 4) {
                    while (tick < this.maxTicks) {
                        final int row = tick / this.numCols;
                        final int col = tick % this.numCols;
                        g.setColor(Color.BLACK);
                        g.drawRect(this.leftMargin + col * this.dx, this.topMargin + row * dy, this.dx - 3, dy - 3);
                        g.setColor((tick < this.numTicks) ? Color.BLACK : Color.WHITE);
                        g.fillRect(this.leftMargin + 1 + col * this.dx, this.topMargin + 1 + row * dy, this.dx - 4, dy - 4);
                        ++tick;
                    }
                }
                else {
                    g.setColor(Color.GRAY);
                    g.fillRect(0, this.topMargin - 2, this.numCols * this.dx + this.leftMargin * 2, this.numRows * dy + 4);
                    while (tick < this.maxTicks) {
                        final int row = tick / this.numCols;
                        final int col = tick % this.numCols;
                        g.setColor((tick < this.numTicks) ? Color.BLACK : Color.WHITE);
                        g.fillRect(this.leftMargin + col * this.dx, this.topMargin + row * dy, this.dx - 1, dy - 1);
                        ++tick;
                    }
                }
            }
        }
        
        public void mouseClicked(final MouseEvent event) {
            if ((event.isMetaDown() || event.isShiftDown()) && this.panelType != 6) {
                new EditTickLabelValueDialog(this);
                return;
            }
            final int col = Math.min((event.getX() - this.leftMargin + 1) / this.dx, this.numCols - 1);
            final int row = Math.min((event.getY() - this.topMargin + 1) / this.dx, this.numRows - 1);
            final int num = row * this.numCols + col + 1;
            this.numTicks = ((num == this.numTicks) ? (num - 1) : num);
            this.fireActionEvent();
            this.repaint();
        }
        
        public void fireActionEvent() {
            final Iterator<ActionListener> it = this.actionListeners.iterator();
            while (it.hasNext()) {
                it.next().actionPerformed(new ActionEvent(this, 0, null));
            }
        }
        
        public void set(final int newNumTicks, final int newMaxTicks) {
            this.numTicks = newNumTicks;
            this.maxTicks = newMaxTicks;
            String tip = String.valueOf(this.numTicks) + "/" + this.maxTicks;
            if (this.panelType != 6) {
                tip = String.valueOf(tip) + " (right-click to edit)";
            }
            this.setToolTipText(tip);
            this.repaint();
        }
        
        public void mouseEntered(final MouseEvent event) {
        }
        
        public void mouseExited(final MouseEvent event) {
        }
        
        public void mousePressed(final MouseEvent event) {
        }
        
        public void mouseReleased(final MouseEvent event) {
        }
        
        public class EditTickLabelValueDialog extends JPanel implements ActionListener, DocumentListener, FocusListener
        {
            TickLabel theTickLabel;
            JLayeredPane editorParent;
            JTextField valueField;
            
            public EditTickLabelValueDialog(final TickLabel owner) {
                super(new BorderLayout());
                this.theTickLabel = owner;
                Container theDialog;
                for (theDialog = this.theTickLabel.getParent(); !(theDialog instanceof JDialog) && theDialog != null; theDialog = theDialog.getParent()) {}
                if (theDialog != null) {
                    this.editorParent = ((JDialog)theDialog).getLayeredPane();
                    final Rectangle newBounds = SwingUtilities.convertRectangle(this.theTickLabel.getParent(), this.theTickLabel.getBounds(), this.editorParent);
                    this.setBounds(newBounds);
                    final JButton okButton = new JButton("Ok");
                    switch (TickLabel.this.panelType) {
                        case 5: {
                            (this.valueField = new JTextField(Integer.toString(owner.getMaxTicks()))).setToolTipText("max value");
                            break;
                        }
                        case 4: {
                            (this.valueField = new JTextField(Integer.toString(owner.getNumTicks()))).setToolTipText("current value");
                            break;
                        }
                        default: {
                            (this.valueField = new JTextField(String.valueOf(owner.numTicks) + "/" + owner.maxTicks)).setToolTipText("current value / max value");
                            break;
                        }
                    }
                    this.valueField.addActionListener(this);
                    this.valueField.addFocusListener(this);
                    this.valueField.getDocument().addDocumentListener(this);
                    this.add(this.valueField, "Center");
                    okButton.addActionListener(this);
                    this.add(okButton, "East");
                    this.editorParent.add(this, JLayeredPane.MODAL_LAYER);
                    this.setVisible(true);
                    this.valueField.grabFocus();
                }
            }
            
            public void storeValues() {
                final String value = this.valueField.getText();
                switch (TickLabel.this.panelType) {
                    case 5: {
                        this.theTickLabel.set(this.theTickLabel.getNumTicks(), FlatTopPropertySheet.this.atoi(value));
                        break;
                    }
                    case 4: {
                        this.theTickLabel.set(FlatTopPropertySheet.this.atoi(value), this.theTickLabel.getMaxTicks());
                        break;
                    }
                    default: {
                        this.theTickLabel.set(FlatTopPropertySheet.this.atoi(value), FlatTopPropertySheet.this.atoiRight(value));
                        break;
                    }
                }
                this.theTickLabel.fireActionEvent();
            }
            
            public void actionPerformed(final ActionEvent event) {
                this.storeValues();
                this.editorParent.remove(this);
            }
            
            public void changedUpdate(final DocumentEvent event) {
                this.theTickLabel.fireActionEvent();
            }
            
            public void insertUpdate(final DocumentEvent event) {
                this.theTickLabel.fireActionEvent();
            }
            
            public void removeUpdate(final DocumentEvent event) {
                this.theTickLabel.fireActionEvent();
            }
            
            public void focusGained(final FocusEvent event) {
            }
            
            public void focusLost(final FocusEvent event) {
                this.storeValues();
            }
        }
    }
}
